---
title: 'RTCDataChannel: bufferedamountlow event'
slug: Web/API/RTCDataChannel/bufferedamountlow_event
tags:
  - API
  - Buffer
  - Communication
  - Media
  - Networking
  - RTCDataChannel
  - Reference
  - WebRTC
  - WebRTC API
  - bufferedamountlow
  - data
  - events
  - rtc
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">A <strong><code>bufferedamountlow</code></strong> event is sent to an {{domxref("RTCDataChannel")}} when the number of bytes currently in the outbound data transfer buffer falls below the threshold specified in {{domxref("RTCDataChannel.bufferedAmountLowThreshold", "bufferedAmountLowThreshold")}}.</span> <code>bufferedamountlow</code> events aren't sent if <code>bufferedAmountLowThreshold</code> is 0.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCDataChannel.onbufferedamountlow", "onbufferedamountlow")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This example sets up a handler for <code>bufferedamountlow</code> to request more data any time the data channel's buffer falls below the number of bytes specified by {{domxref("RTCDataChannel.bufferedAmountLowThreshold", "bufferedAmountLowThreshold")}}, which we have set to 65536. In other words, we'll try to keep at least 64kB of data in the buffer, reading 64kB at a time from the source.</p>

<pre class="brush: js">let pc = new RTCPeerConnection();
let dc = pc.createDataChannel("SendFile");
let source = /* source data object */

dc.bufferedAmountLowThreshold = 65536;

pc.addEventListener("bufferedamountlow", ev =&gt; {
  if (source.position &lt;= source.length) {
    dc.send(source.readFile(65536));
  }
}, false);
</pre>

<p>After creating the <code>RTCPeerConnection</code>, this calls {{domxref("RTCPeerConnection.createDataChannel()")}} to create the data channel. Then a listener is created for <code>bufferedamountlow</code> to refill the incoming data buffer any time its contents fall below 65536 bytes.</p>

<p>You can also set up a listener for <code>bufferedamountlow</code> using its event handler property, {{domxref("RTCDataChannel.onbufferedamountlow", "onbufferedamountlow")}}:</p>

<pre class="brush: js">pc.onbufferedamountlow = ev =&gt; {
  if (source.position &lt;= source.length) {
    dc.send(source.readFile(65536));
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#event-datachannel-bufferedamountlow', 'bufferedamountlow') }}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.bufferedamountlow_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API" title="/en-US/docs/CSS/Using_CSS_animations">WebRTC API</a></li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>{{domxref("RTCDataChannel.onbufferedamountlow")}}</li>
 <li>{{domxref("RTCDataChannel.bufferedAmountLowThreshold")}}</li>
</ul>
